virt-what.in: warn about missing cpuid-virt helper program
[virt-what.git] / virt-what.in
1 #!/bin/sh -
2 # @configure_input@
3 # Copyright (C) 2008-2011 Red Hat Inc.
4 #
5 # This program is free software; you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation; either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program; if not, write to the Free Software
17 # Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
18
19 # 'virt-what' tries to detect the type of virtualization being
20 # used (or none at all if we're running on bare-metal).  It prints
21 # out one or more lines each being a 'fact' about the virtualization.
22 #
23 # Please see also the manual page virt-what(1).
24 # This script should be run as root.
25 #
26 # The following resources were useful in writing this script:
27 # . http://dmo.ca/blog/detecting-virtualization-on-linux/
28
29 # Do not allow unset variables, and set defaults.
30 set -u
31 root=''
32 skip_qemu_kvm=false
33
34 VERSION="@VERSION@"
35
36 fail() {
37     echo "virt-what: $1" >&2
38     exit 1
39 }
40
41 usage() {
42     echo "virt-what [options]"
43     echo "Options:"
44     echo "  --help          Display this help"
45     echo "  --version       Display version and exit"
46     exit 0
47 }
48
49 # Handle the command line arguments, if any.
50
51 TEMP=$(getopt -o v --long help --long version --long test-root: -n 'virt-what' -- "$@")
52 if [ $? != 0 ]; then exit 1; fi
53 eval set -- "$TEMP"
54
55 while true; do
56     case "$1" in
57         --help) usage ;;
58         --test-root)
59             # Deliberately undocumented: used for 'make check'.
60             root="$2"
61             shift 2
62             ;;
63         -v|--version) echo "$VERSION"; exit 0 ;;
64         --) shift; break ;;
65         *) fail "internal error ($1)" ;;
66     esac
67 done
68
69 # Add /sbin and /usr/sbin to the path so we can find system
70 # binaries like dmidecode.
71 # Add /usr/libexec to the path so we can find the helper binary.
72 prefix=@prefix@
73 exec_prefix=@exec_prefix@
74 PATH="${root}@libexecdir@:${root}/sbin:${root}/usr/sbin:${PATH}"
75
76 # Check we're running as root.
77 EFFUID=$(id -u) || fail "failed to get current user id"
78
79 if [ "x$root" = "x" ] && [ "$EFFUID" -ne 0 ]; then
80     fail "this script must be run as root"
81 fi
82
83 # Try to locate the CPU-ID helper program
84 CPUID_HELPER=$(which virt-what-cpuid-helper 2>/dev/null)
85 if [ -z "$CPUID_HELPER" ] ; then
86     fail "virt-what-cpuid-helper program not found in \$PATH"
87 fi
88
89 # Many fullvirt hypervisors give an indication through CPUID.  Use the
90 # helper program to get this information.
91
92 cpuid=$(virt-what-cpuid-helper)
93
94 # Check for various products in the BIOS information.
95 # Note that dmidecode doesn't exist on non-PC architectures.  On these,
96 # this will return an error which is ignored (error message redirected
97 # into $dmi variable).
98
99 dmi=$(LANG=C dmidecode 2>&1)
100
101 # Architecture.
102 # Note for the purpose of testing, we only call uname with -p option.
103
104 arch=$(uname -p)
105
106 # Check for VMware.
107 # cpuid check added by Chetan Loke.
108
109 if [ "$cpuid" = "VMwareVMware" ]; then
110     echo vmware
111 elif echo "$dmi" | grep -q 'Manufacturer: VMware'; then
112     echo vmware
113 fi
114
115 # Check for Hyper-V.
116 # http://blogs.msdn.com/b/sqlosteam/archive/2010/10/30/is-this-real-the-metaphysics-of-hardware-virtualization.aspx
117 if [ "$cpuid" = "Microsoft Hv" ]; then
118     echo hyperv
119 fi
120
121 # Check for VirtualPC.
122 # The negative check for cpuid is to distinguish this from Hyper-V
123 # which also has the same manufacturer string in the SM-BIOS data.
124 if [ "$cpuid" != "Microsoft Hv" ] &&
125     echo "$dmi" | grep -q 'Manufacturer: Microsoft Corporation'; then
126     echo virtualpc
127 fi
128
129 # Check for VirtualBox.
130 # Added by Laurent Léonard.
131 if echo "$dmi" | grep -q 'Manufacturer: innotek GmbH'; then
132     echo virtualbox
133 fi
134
135 # Check for OpenVZ / Virtuozzo.
136 # Added by Evgeniy Sokolov.
137 # /proc/vz - always exists if OpenVZ kernel is running (inside and outside
138 # container)
139 # /proc/bc - exists on node, but not inside container.
140
141 if [ -d "${root}/proc/vz" -a ! -d "${root}/proc/bc" ]; then
142     echo openvz
143 fi
144
145 # Check for LXC containers
146 # http://www.freedesktop.org/wiki/Software/systemd/ContainerInterface
147 # Added by Marc Fournier
148
149 if [ -e "${root}/proc/1/environ" ] &&
150     cat "${root}/proc/1/environ" | tr '\000' '\n' | grep -Eiq '^container='; then
151     echo lxc
152 fi
153
154 # Check for Linux-VServer
155 if cat "${root}/proc/self/status" | grep -q "VxID: [0-9]*"; then
156     echo linux_vserver
157     if grep -q "VxID: 0$" "${root}/proc/self/status"; then
158         echo linux_vserver-host
159     else
160         echo linux_vserver-guest
161     fi
162 fi
163
164 # Check for UML.
165 # Added by Laurent Léonard.
166 if grep -q 'UML' "${root}/proc/cpuinfo"; then
167     echo uml
168 fi
169
170 # Check for IBM PowerVM Lx86 Linux/x86 emulator.
171 if grep -q '^vendor_id.*PowerVM Lx86' "${root}/proc/cpuinfo"; then
172     echo powervm_lx86
173 fi
174
175 # Check for Hitachi Virtualization Manager (HVM) Virtage logical partitioning.
176 if echo "$dmi" | grep -q 'Manufacturer.*HITACHI' &&
177    echo "$dmi" | grep -q 'Product.* LPAR'; then
178     echo virtage
179 fi
180
181 # Check for IBM SystemZ.
182 if grep -q '^vendor_id.*IBM/S390' "${root}/proc/cpuinfo"; then
183     echo ibm_systemz
184     if [ -f "${root}/proc/sysinfo" ]; then
185         if grep -q 'VM.*Control Program.*z/VM' "${root}/proc/sysinfo"; then
186             echo ibm_systemz-zvm
187         elif grep -q '^LPAR' "${root}/proc/sysinfo"; then
188             echo ibm_systemz-lpar
189         else
190             # This is unlikely to be correct.
191             echo ibm_systemz-direct
192         fi
193     fi
194 fi
195
196 # Check for Parallels.
197 if echo "$dmi" | grep -q 'Vendor: Parallels'; then
198     echo parallels
199     skip_qemu_kvm=true
200 fi
201
202 # Check for Xen.
203
204 if [ "$cpuid" = "XenVMMXenVMM" ]; then
205     echo xen; echo xen-hvm
206     skip_qemu_kvm=true
207 elif [ -d "${root}/proc/xen" ]; then
208     echo xen
209     if grep -q "control_d" "${root}/proc/xen/capabilities" 2>/dev/null; then
210         echo xen-dom0
211     else
212         echo xen-domU
213     fi
214     skip_qemu_kvm=true
215 elif [ -f "${root}/sys/hypervisor/type" ] &&
216     grep -q "xen" "${root}/sys/hypervisor/type"; then
217     # Ordinary kernel with pv_ops.  There does not seem to be
218     # enough information at present to tell whether this is dom0
219     # or domU.  XXX
220     echo xen
221 elif [ "$arch" = "ia64" ]; then
222     if [ -d "${root}/sys/bus/xen" -a ! -d "${root}/sys/bus/xen-backend" ]; then
223         # PV-on-HVM drivers installed in a Xen guest.
224         echo xen
225         echo xen-hvm
226     else
227         # There is no virt leaf on IA64 HVM.  This is a last-ditch
228         # attempt to detect something is virtualized by using a
229         # timing attack.
230         virt-what-ia64-xen-rdtsc-test > /dev/null 2>&1
231         case "$?" in
232             0) ;; # not virtual
233             1) # Could be some sort of virt, or could just be a bit slow.
234                 echo virt
235         esac
236     fi
237 fi
238
239 # Check for QEMU/KVM.
240 #
241 # Parallels exports KVMKVMKVM leaf, so skip this test if we've already
242 # seen that it's Parallels.  Xen uses QEMU as the device model, so
243 # skip this test if we know it is Xen.
244
245 if ! "$skip_qemu_kvm"; then
246     if [ "$cpuid" = "KVMKVMKVM" ]; then
247         echo kvm
248     else
249         # XXX This is known to fail for qemu with the explicit -cpu
250         # option, since /proc/cpuinfo will not contain the QEMU
251         # string.  The long term fix for this would be to export
252         # another CPUID leaf for non-accelerated qemu.
253         if grep -q 'QEMU' "${root}/proc/cpuinfo"; then
254             echo qemu
255         fi
256     fi
257 fi
258
259 # Check for Docker.
260 if [ -f "${root}/.dockerinit" ]; then
261         echo docker
262 fi